;;Copyright <2022> <Dahlia Games>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.


.area _CODE
.include "Manager/enemigo.inc"

.globl _enemigos
.globl _valores_enemigo
.globl _enemigos_creados
inicializar_enemigo::
    ld ix,#_enemigos_creados
    ld a,(ix)
    ld ix,#_enemigos
    ld hl,#_valores_enemigo
comprobar_posicion:
    add a,#0
    jr z ,posicion_conseguida

    ld bc,#sizeofenemy
    add ix,bc
    add a,#-1
    jr comprobar_posicion

posicion_conseguida:

    ld a,(hl)
    ld enemy_y(ix),a ;;posicion y
    inc hl
    ld a,(hl)
    ld enemy_x(ix),a  ;;posicion x
    inc hl
    ld a,(hl)
    ld enemy_v(ix),a  ;;velocidad x
    inc hl
    ld a,(hl)
    ld enemy_action(ix),a ;;saltando subiendo=1, saltando cayendo=2
    inc hl


    ld ix,#_enemigos_creados
    inc (ix)

ret

eliminarEntidadE::
push ix
ld hl,#_enemigos
ld ix, #_enemigos_creados
ld a,(ix)
ld bc, #sizeofenemy
pop ix

QuedanEnemigosAun:

sub a, #1
jr z, #ultimaEntidadEnemigo

add hl, bc

jr QuedanEnemigosAun



ultimaEntidadEnemigo:

call Cambiar_enemigo_final
push ix
ld ix,#_enemigos_creados
ld a, (ix)
add a, #-1
ld (ix), a
pop ix
ret



Cambiar_enemigo_final::
ld bc, #sizeofenemy
push ix
pop de
ldir
ret

crearEnemigo::
    sub a, #0
    jp z, noEsNingunTipo 
    ld ix,#_valores_enemigo

    sub a, #1
    jr nz, noEsUnEnemigoUno

    ld enemy_y(ix),#36 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#0 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos

    noEsUnEnemigoUno:

    sub a, #1
    jr nz, noEsUnEnemigoDos

    ld enemy_y(ix),#139 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#0 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
    
    noEsUnEnemigoDos:


    sub a, #1
    jr nz, noEsUnEnemigoTres

    ld enemy_y(ix),#51 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#1 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
  
    noEsUnEnemigoTres:


    sub a, #1
    jr nz, noEsUnEnemigoCuatro

    ld enemy_y(ix),#155 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#1 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
    
    noEsUnEnemigoCuatro:


    sub a, #1
    jr nz, noEsUnEnemigoCinco

    ld enemy_y(ix),#25 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#2 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
  
    noEsUnEnemigoCinco:


    sub a, #1
    jr nz, noEsUnEnemigoSeis

    ld enemy_y(ix),#120 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#2 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
    
    noEsUnEnemigoSeis:

    sub a, #1
    jr nz, noEsUnEnemigoSiete

    ld enemy_y(ix),#36 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-2 ;;velocidad x
    ld enemy_action(ix),#3 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
  
    noEsUnEnemigoSiete:


    sub a, #1
    jr nz, noEsUnEnemigoOcho


    ld enemy_y(ix),#139 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-2 ;;velocidad x
    ld enemy_action(ix),#3 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
    
    noEsUnEnemigoOcho:

    sub a, #1
    jr nz, noEsUnEnemigoNueve

    ld enemy_y(ix),#24 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#4 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos

    noEsUnEnemigoNueve:


    sub a, #1
    jr nz, noEsUnEnemigoDiez

    ld enemy_y(ix),#127 ;;posicion y
    ld enemy_x(ix),#60 ;;posicion x
    ld enemy_v(ix),#-1 ;;velocidad x
    ld enemy_action(ix),#4 ;;saltando subiendo=1, saltando cayendo=2
    jp datosPuestos
    
    noEsUnEnemigoDiez:
    datosPuestos:


    call inicializar_enemigo
    noEsNingunTipo:

ret