
;;Copyright <2022> <Dahlia Games>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
.include "cpctelera.h.s"
.include "Manager/jugador.inc"
.include "Manager/enemigo.inc"
.include "sys/physics.inc"
.include "sys/render.inc"
.include "sys/colisiones.inc"
.include "Manager/niveles.inc"





.area _DATA
_jugador::
.ds 6
_jugadorDos::
.ds 6
_enemigos::
.ds 24
_valores_enemigo::
.ds 4
_enemigos_creados::
.db 0 
_menu_posicion::
.db 1
_posicion_lectura::
.db 30
_posicion_nivel::
.db 0,0
_nivel_actual::
.db 1
_tiempo_espera_nivel::
.db 255


.area _CODE


.globl cpct_waitVSYNC_asm
.globl mirar_teclado
.globl render_menu
.globl input_menu
.globl render_menu_ganado
.globl input_menu_ganado
.globl cargaMapa
.globl leerNivel
.globl empezarNivel
.globl render_menu_perdido
.globl input_menu_perdido
.globl render_menu_final
.globl input_menu_final
.globl titulo_nivel
.globl menu_image
.globl menu_final

_main::
   call inicializar_jugador
   




   call render_init

   
pre_loop_menu::
ld ix, #_posicion_lectura
ld (ix), #30
ld ix, #_enemigos_creados
ld (ix),#0
cpctm_clearScreen_asm 0x00 
call menu_image


loop_menu::

call render_menu
call input_menu

jr loop_menu





previoLoop::

   cpctm_clearScreen_asm 0x00
   ld ix,#_tiempo_espera_nivel
   ld (ix),#255
   mini_loop_nivel:
   call titulo_nivel
   jp mini_loop_nivel

   continuar::
   call cargaMapa
   call empezarNivel




loop_juego::

   call leerNivel
   call mirar_teclado
   call fisicas_jugador
   call fisicas_enemigos
   call detectar_colisiones
   ;;Aqui todas las partes del juego:
      ;;input del jugador
      ;;Movimiento del jugador
      ;;Movimiento del mapa
      ;;Fisica (si ha chocado)
      ;;Esperar vsync
      ;;Cambiar la pantalla
      call cpct_waitVSYNC_asm
      call render_jugador
      call render_enemigos
 
   jr    loop_juego




menu_has_ganado::
   ld a,(_nivel_actual)
   sub a, #5
   jp nz, SeguirNormal
      jp menu_final_juego
   SeguirNormal:
   ld a,(_nivel_actual)
   inc a
   ld ix,#_nivel_actual
   ld (ix),a
   ld ix, #_posicion_lectura
   ld (ix), #30
   ld ix, #_enemigos_creados
   ld (ix),#0

   cpctm_clearScreen_asm 0x00

loop_menu_has_ganado::
   call render_menu_ganado
   call input_menu_ganado
jr loop_menu_has_ganado


volver_empezar::
     call cargaMapa
     ld ix,#_nivel_actual
     ld (ix),#1
     call empezarNivel

jp loop_juego





menu_has_perdido::
   ld ix, #_posicion_lectura
   ld (ix), #30
   ld ix, #_enemigos_creados
   ld (ix),#0

   cpctm_clearScreen_asm 0x00

loop_menu_has_perdido::
   call render_menu_perdido
   call input_menu_perdido
jr loop_menu_has_perdido


menu_final_juego::
   ld ix, #_posicion_lectura
   ld (ix), #30
   ld ix, #_enemigos_creados
   ld (ix),#0

   cpctm_clearScreen_asm 0x00
   call menu_final
   loop_menu_has_final::
   call render_menu_final
   call input_menu_final
jr loop_menu_has_final

ret