;;Copyright <2022> <Dahlia Games>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.

.include "cpctelera.h.s"


.area _CODE
.globl cpct_scanKeyboard_asm
.globl cpct_isAnyKeyPressed_asm
.globl cpct_isKeyPressed_asm
.globl _jugador
.globl _jugadorDos
.globl _menu_posicion
.globl loop_juego
.globl previoLoop
.globl crearEnemigo
.globl volver_empezar
.globl pre_loop_menu
_space_pulsed:
.db 0


comprueba_suelta:
    ld a,(_space_pulsed)
    sub a, #0
    jr nz, espacio_pulsado
        call cpct_isAnyKeyPressed_asm
        cp #0
        jr z,noCambiar
            ld a,#1
            ld (_space_pulsed),a
            ret
    espacio_pulsado:
    call cpct_isAnyKeyPressed_asm
        cp #0
        jr nz,noCambiar
            ld a,#0
            ld (_space_pulsed),a
            ret
    noCambiar:
    ld a,#0
ret


input_menu::
call cpct_scanKeyboard_asm
call comprueba_suelta
cp #0
jr z, ningunaTecla
call cpct_isAnyKeyPressed_asm
;;Miramos si se pulsa alguna tecla
jr z, ningunaTecla ;;saltamos pq no hay tecla
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr z, noAbajo
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#1
    jr nz, noAbajo
    ld a,#2
    ld (ix),a

noAbajo:


ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, noArriba
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#2
    jr nz, noArriba
    ld a,#1
    ld (ix),a

noArriba:


ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr z, noAcepta
    ld a,(_menu_posicion)
    sub a,#1
    jr nz, segundaOpcion
        jp previoLoop
    segundaOpcion:
    jp volver_empezar
noAcepta:

ningunaTecla:

ret




input_menu_ganado::
call cpct_scanKeyboard_asm
call comprueba_suelta
call cpct_isAnyKeyPressed_asm
;;Miramos si se pulsa alguna tecla
jr z, ningunaTecla2 ;;saltamos pq no hay tecla
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr z, noAbajo2
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#1
    jr nz, noAbajo2
    ld a,#2
    ld (ix),a

noAbajo2:


ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, noArriba2
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#2
    jr nz, noArriba2
    ld a,#1
    ld (ix),a

noArriba2:


ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr z, noAcepta2
    ld a,(_menu_posicion)
    sub a,#1
    jr nz, segundaOpcion2
        jp previoLoop
    segundaOpcion2:
        jp pre_loop_menu
noAcepta2:

ningunaTecla2:

ret



input_menu_perdido::
call cpct_scanKeyboard_asm
call comprueba_suelta
call cpct_isAnyKeyPressed_asm
;;Miramos si se pulsa alguna tecla
jr z, ningunaTecla2 ;;saltamos pq no hay tecla
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr z, noAbajo3
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#1
    jr nz, noAbajo3
    ld a,#2
    ld (ix),a

noAbajo3:


ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, noArriba3
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#2
    jr nz, noArriba3
    ld a,#1
    ld (ix),a

noArriba3:


ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr z, noAcepta3
    ld a,(_menu_posicion)
    sub a,#1
    jr nz, segundaOpcion2
        jp previoLoop
    segundaOpcion3:
        jp pre_loop_menu
noAcepta3:

ningunaTecla3:

ret




input_menu_final::
call cpct_scanKeyboard_asm
call comprueba_suelta
call cpct_isAnyKeyPressed_asm
;;Miramos si se pulsa alguna tecla
jr z, ningunaTecla4 ;;saltamos pq no hay tecla
    ld hl, #Key_A
    call cpct_isKeyPressed_asm
    jr z, noAbajo4
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#1
    jr nz, noAbajo4
    ld a,#2
    ld (ix),a

noAbajo4:


ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, noArriba4
    ld ix,#_menu_posicion
    ld a,(ix)
    sub a,#2
    jr nz, noArriba4
    ld a,#1
    ld (ix),a

noArriba4:


ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr z, noAcepta4
    ld a,(_menu_posicion)
    sub a,#1
    jr nz, segundaOpcion4
        jp pre_loop_menu
    segundaOpcion4:
        jp volver_empezar
noAcepta4:

ningunaTecla4:

ret







mirar_teclado::



call cpct_scanKeyboard_asm
call cpct_isAnyKeyPressed_asm
;;Miramos si se pulsa alguna tecla
jp z, nohaytecla ;;saltamos pq no hay tecla


    ld ix, #_jugador
    ld a, 3(ix)
    add a,#0
    jp nz, noEspacio
    ld hl, #Key_P
    call cpct_isKeyPressed_asm
    jr z, noEspacio
    ld ix,#_jugador
    ld 2(ix),#-9
    ld 3(ix),#1
    noEspacio:

    ld ix, #_jugadorDos
    ld a, 3(ix)
    add a,#0
    jp nz, yaPulsada
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr z, nohaytecla
    ld ix,#_jugadorDos
    ld 2(ix),#-9
    ld 3(ix),#1

nohaytecla:
yaPulsada:
ret
;;Si, se pulsa una tecla miramos si es el espacio
