;;Copyright <2022> <Dahlia Games>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.

.include "cpctelera.h.s"
.include "Manager/jugador.inc"
.include "Manager/enemigo.inc"

.area _CODE
.globl _jugador
.globl _enemigos
.globl _enemigos_creados
.globl _jugadorDos
.globl borraRastroFinal


fisicas_jugador::
ld ix, #_jugador
call fisicas_ambos_juagdores
ld ix, #_jugadorDos
call fisicas_ambos_juagdores
ret

fisicas_ambos_juagdores::
ld a, jugador_estado(ix)
add a,#-1
jr nz, nosalta

ld a, jugador_y(ix)
ld b, jugador_v(ix)
add a, b
ld jugador_y(ix), a
ld a,b 
add a, #1
jr z, velocidad0
ld jugador_v(ix), a

jr acabado

velocidad0:
ld jugador_estado(ix),#2
ld jugador_v(ix),#1
ld tiempo_aire(ix),#0
jr acabado
nosalta:

ld a, tiempo_aire(ix)
add a,#-10
jr z, noAire
ld a, tiempo_aire(ix)
add a,#1
ld tiempo_aire(ix), a
jr nocae
noAire:


ld a, jugador_estado(ix)
add a,#-2
jr nz, nocae

ld a, jugador_y(ix)
ld b, jugador_v(ix)
add a, b
ld jugador_y(ix), a
ld a,b 
add a, #-9
jr z, llegosuelo
ld a,b
add a,#1
ld jugador_v(ix), a

jr acabado

llegosuelo:
ld jugador_estado(ix),#0
ld jugador_v(ix),#0 




acabado:
nocae:



ret

fisicas_enemigos::
    ld ix,#_enemigos_creados
    ld a,(ix)
    ld ix,#_enemigos
    ld de,#4
    continuar_fisicas:
    cp a,#0
    jr z, fisicasEnemigosAcabadas
    push af
    call fisica_enemigo
    pop af
    sub a,#1
    ld de,#4
    add ix,de

    jr continuar_fisicas
    fisicasEnemigosAcabadas:

ret

fisica_enemigo::
    ld a, enemy_x(ix)
    ld b, enemy_v(ix)
    sub a, #2
    jp c, eliminar_enemigo
    ld a, enemy_x(ix)
    add a, b
    jp finalFisicasEnemigo
    eliminar_enemigo:
    call borraRastroFinal
    call eliminarEntidadE
    jr entidadEnemigaEliminada
    finalFisicasEnemigo:
    ld enemy_x(ix), a

    entidadEnemigaEliminada:
ret