;;Copyright <2022> <Dahlia Games>
;;Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files 
;;(the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, 
;;publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
;;subject to the following conditions:

;;The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
;;MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
;;DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE 
;;OR OTHER DEALINGS IN THE SOFTWARE.
.include "cpctelera.h.s"
.include "Manager/enemigo.inc"
.include "Manager/jugador.inc"
.include "assets/assets.inc"

.area _CODE
.globl _jugador
.globl _jugadorDos
.globl _enemigos
.globl cpct_disableFirmware_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_drawSprite_asm
.globl cpct_setPalette_asm
.globl cpct_setVideoMode_asm
.globl _g_palette
.globl _sprt_toro
.globl _sprt_torero
.globl _enemigos_creados
.globl _menu_posicion
.globl _sprt_jugar
.globl _sprt_salir
.globl _sprt_cabeza
.globl _sprt_vacaS
.globl _sprt_valla
.globl _sprt_pajaro
.globl _sprt_obrero
.globl _sprt_meta
.globl _sprt_siguiente
.globl _sprt_menu
.globl _sprt_has_ganado
.globl _sprt_nueva
.globl _sprt_reintentar
.globl _sprt_has_perdido
.globl _sprt_acabado
.globl loop_juego
.globl continuar
.globl _sprt_nuevaSegunda
.globl _sprt_nuevaTercera
.globl _sprt_nuevaCuarta
.globl _sprt_nuevaQuinta
.globl _sprt_nuevaSexta


.globl cpct_zx7b_decrunch_s_asm
.globl _menuprin_z_end
.globl _menufinal_z_end


.globl _nivel_actual

.globl cpct_setDrawCharM1_asm 
.globl cpct_drawStringM1_asm
.globl _tiempo_espera_nivel


menu_image::
    ld hl, #_menuprin_z_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm
ret

menu_final::
    ld hl, #_menufinal_z_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm
ret


render_menu::
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #110
    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_jugar
    ld b, #10
    ld c, #15
    call cpct_drawSprite_asm
    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #110

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_nueva
    ld b, #7
    ld c, #37
    call cpct_drawSprite_asm

  
    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #1
    jp nz, noCuadrado
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm
    

    noCuadrado:

    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #2
    jp nz, noCuadrado2
    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm

    noCuadrado2:
ret


render_menu_ganado::
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #100
    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_siguiente
    ld b, #7
    ld c, #38
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_menu
    ld b, #7
    ld c, #38
    call cpct_drawSprite_asm



    ld de, #CPCT_VMEM_START_ASM

    ld b, #10
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_has_ganado
    ld b, #40
    ld c, #40
    call cpct_drawSprite_asm

  
    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #1
    jp nz, noCuadrado3
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm
    

    noCuadrado3:

    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #2
    jp nz, noCuadrado4
    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm

    noCuadrado4:
ret


render_menu_perdido::
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #100
    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_reintentar
    ld b, #7
    ld c, #27
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_menu
    ld b, #7
    ld c, #38
    call cpct_drawSprite_asm



    ld de, #CPCT_VMEM_START_ASM

    ld b, #10
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_has_perdido
    ld b, #40
    ld c, #45
    call cpct_drawSprite_asm

  
    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #1
    jp nz, noCuadrado5
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm
    

    noCuadrado5:

    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #2
    jp nz, noCuadrado6
    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm

    noCuadrado6:
ret





render_menu_final::
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #100
    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_menu
    ld b, #7
    ld c, #38
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_nueva
    ld b, #7
    ld c, #37
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #10
    ld c, #100

    call cpct_getScreenPtr_asm 
    ex de,hl


    ld hl,#_sprt_acabado
    ld b, #40
    ld c, #40
    call cpct_drawSprite_asm

  
    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #1
    jp nz, noCuadrado7
    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm
    

    noCuadrado7:

    ld ix,#_menu_posicion
    ld a, (ix)
    sub a, #2
    jp nz, noCuadrado8
    ld de, #CPCT_VMEM_START_ASM

    ld b, #100
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl, #_sprt_cabeza
    ld b, #13
    ld c, #7
    call cpct_drawSprite_asm


    ld de, #CPCT_VMEM_START_ASM

    ld b, #70
    ld c, #10

    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a, #0x00
    ld b, #13
    ld c, #7
    call cpct_drawSolidBox_asm

    noCuadrado8:
ret



render_init::
    call cpct_disableFirmware_asm
    ld de, #16 
    ld hl, #_g_palette
    call cpct_setPalette_asm
    ld c,#0
    call cpct_setVideoMode_asm

ret 

render_jugador::
        ld ix,#_jugador
        call render_entidad_jugador
        ld ix,#_jugadorDos
        call render_entidad_jugador
ret

render_entidad_jugador::
    ld de, #CPCT_VMEM_START_ASM



    ld a, jugador_estado(ix)
    add a,#-1
    jr nz, renderSinSaltar
    push af
    ld a,0(ix)
    add a,#9
    ld b, a
    pop af
    ld c, 1(ix)
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_sprt_vacaS
    jr renderSaltando

    renderSinSaltar:
    ld b, 0(ix)
    ld c, 1(ix)
    call cpct_getScreenPtr_asm 
    ex de,hl
    ld hl,#_sprt_toro
    renderSaltando:
    ld b, #25
    ld c, #17
    call cpct_drawSprite_asm
ret


borraRastroFinal::

    ld de, #CPCT_VMEM_START_ASM
    ld b, enemy_y(ix)
    ld c, #0



    call cpct_getScreenPtr_asm 
    ex de,hl
    ld a,enemy_action(ix)

    sub a,#0
    jr nz, noBorroEnemigo0
        ld b, #36
        ld c, #12
        jr borrado

    noBorroEnemigo0:

    sub a,#1
    jr nz, noBorroEnemigo1
        ld b, #20
        ld c, #17
        jr borrado

    noBorroEnemigo1:

    sub a,#1
    jr nz, noBorroEnemigo2
        ld b, #20
        ld c, #17
        jr borrado

    noBorroEnemigo2:

    sub a,#1
    jr nz, noBorroEnemigo3
        ld b, #36
        ld c, #12
        jr borrado

    noBorroEnemigo3:

    borrado:



    ld a, #0x00
    call cpct_drawSolidBox_asm

ret

render_enemigos::
    ld ix,#_enemigos_creados
    ld a,(ix)
    ld ix,#_enemigos
    ld de,#4
    continuar_render:
    cp a,#0
    jr z, nomasenemigos
    push af
    call render_enemigo
    pop af
    sub a,#1
    ld de,#4
    add ix,de

    jr continuar_render
    nomasenemigos:

ret

render_enemigo::
    ld de, #CPCT_VMEM_START_ASM
    ld b, enemy_y(ix)
    ld c, enemy_x(ix)
    call cpct_getScreenPtr_asm 
    ex de,hl

    ld a,enemy_action(ix)

    sub a,#0
    jr nz, noRenderTipoCero
    ld hl,#_sprt_torero
    ld b, #36
    ld c, #12
    noRenderTipoCero:

    sub a,#1
    jr nz, noRenderTipoUno
    ld hl,#_sprt_valla
    ld b, #20
    ld c, #17
    noRenderTipoUno:

    sub a,#1
    jr nz, noRenderTipoDos
    ld hl,#_sprt_pajaro
    ld b, #20
    ld c, #17
    noRenderTipoDos:

    sub a,#1
    jr nz, noRenderTipoTres
    ld hl,#_sprt_obrero
    ld b, #36
    ld c, #12
    noRenderTipoTres:
    
    sub a,#1
    jr nz, noRenderTipoCuatro
    ld hl,#_sprt_meta
    ld b, #48
    ld c, #16
    noRenderTipoCuatro:


    call cpct_drawSprite_asm

ret


sys_render_tilemap:
    ld bc, #0x1914
    ld de, #20
    ld hl, #_tiles0_0
    call cpct_etm_setDrawTilemap4x8_ag_asm

    ld hl, #CPCT_VMEM_START_ASM
    ld de, #_level0
    call cpct_etm_drawTilemap4x8_ag_asm
ret

cargaMapa::
    call sys_render_tilemap
ret


titulo_nivel::
    ld de, #CPCT_VMEM_START_ASM
    ld b, #70
    ld c, #115
    call cpct_getScreenPtr_asm 
    ex de,hl

    ld a,(_nivel_actual)
    sub a,#1
    jr nz, noPreUno
    ld hl,#_sprt_nuevaSegunda
    ld b, #10
    ld c, #12
    call cpct_drawSprite_asm
    noPreUno:

    sub a,#1
    jr nz, noPreDos
    ld hl,#_sprt_nuevaTercera
  ld b, #10
    ld c, #12
    call cpct_drawSprite_asm
    noPreDos:

    sub a,#1
    jr nz, noPreTres
    ld hl,#_sprt_nuevaCuarta
  ld b, #10
    ld c, #12
    call cpct_drawSprite_asm
    noPreTres:

    sub a,#1
    jr nz, noPreCuatro
    ld hl,#_sprt_nuevaQuinta
  ld b, #10
    ld c, #12
    call cpct_drawSprite_asm
    noPreCuatro:
    
    sub a,#1
    jr nz, noPreCinco
    ld hl,#_sprt_nuevaSexta
   ld b, #10
    ld c, #12
    call cpct_drawSprite_asm
    noPreCinco:


    ld ix, #_tiempo_espera_nivel
    ld a,(ix)
    dec a
    ld (ix),a
    sub a,#1
    jr c, acabadaEspera
        ret
    acabadaEspera:

    jp continuar

ret


